package blusunrize.immersiveengineering.client.render;

import blusunrize.immersiveengineering.api.tool.BelljarHandler.IPlantHandler;
import blusunrize.immersiveengineering.client.ClientUtils;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.metal.TileEntityBelljar;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.client.model.obj.OBJModel.OBJState;
import net.minecraftforge.common.property.IExtendedBlockState;
import net.minecraftforge.common.property.Properties;
import org.lwjgl.opengl.GL11;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class TileRenderBelljar extends TileEntitySpecialRenderer<TileEntityBelljar>
{
	private static HashMap<EnumFacing, List<BakedQuad>> quads = new HashMap<>();
	private static HashMap<IBlockState, List<BakedQuad>> plantQuads = new HashMap<>();

	@Override
	public void func_180535_a(TileEntityBelljar tile, double x, double y, double z, float partialTicks, int destroyStage)
	{
		if(tile.dummy!=0 || !tile.func_145831_w().func_175668_a(tile.func_174877_v(), false))
			return;
		final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
		BlockPos blockPos = tile.func_174877_v();
		if(!quads.containsKey(tile.getFacing()))
		{
			IBlockState state = func_178459_a().func_180495_p(blockPos);
			if(state.func_177230_c() != IEContent.blockMetalDevice1)
				return;
			state = state.func_185899_b(func_178459_a(), blockPos);
			IBakedModel model = blockRenderer.func_175023_a().func_178125_b(state);
			if(state instanceof IExtendedBlockState)
				state = ((IExtendedBlockState)state).withProperty(Properties.AnimationProperty, new OBJState(Arrays.asList("glass"), true));
			quads.put(tile.getFacing(), model.func_188616_a(state, null, 0));
		}
		ClientUtils.bindAtlas();
		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(x, y, z);

		RenderHelper.func_74518_a();
		GlStateManager.func_179112_b(770, 771);
		GlStateManager.func_179147_l();
		GlStateManager.func_179129_p();
		if(Minecraft.func_71379_u())
			GlStateManager.func_179103_j(7425);
		else
			GlStateManager.func_179103_j(7424);
		Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);
		VertexBuffer worldRenderer = Tessellator.func_178181_a().func_178180_c();


		GlStateManager.func_179089_o();
		IPlantHandler plantHandler = tile.getCurrentPlantHandler();
		if(plantHandler!=null)
		{
			GlStateManager.func_179094_E();
			GlStateManager.func_179137_b(0, 1.0625, 0);
			GlStateManager.func_179131_c(1, 1, 1, 1);
			float scale = plantHandler.getRenderSize(tile.getInventory()[1], tile.getInventory()[0], tile.renderGrowth, tile);
			GlStateManager.func_179109_b((1-scale)/2, 0, (1-scale)/2);
			GlStateManager.func_179152_a(scale, scale, scale);
			if(!plantHandler.overrideRender(tile.getInventory()[1], tile.getInventory()[0], tile.renderGrowth, tile, blockRenderer))
			{
				IBlockState[] states = plantHandler.getRenderedPlant(tile.getInventory()[1], tile.getInventory()[0], tile.renderGrowth, tile);
				if(states==null||states.length < 1)
					return;
				for(IBlockState s : states)
				{
					List<BakedQuad> plantQuadList = plantQuads.get(s);
					if(plantQuadList==null)
					{
						IBakedModel plantModel = blockRenderer.func_184389_a(s);
						plantQuadList = plantModel.func_188616_a(s,null,0);
						for(EnumFacing f : EnumFacing.values())
							plantQuadList.addAll(plantModel.func_188616_a(s,f,0));
						plantQuads.put(s, plantQuadList);
					}
					if(plantQuadList!=null)
					{
						GlStateManager.func_179094_E();
						worldRenderer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
						ClientUtils.renderModelTESR(plantQuadList, worldRenderer, tile.func_145831_w().func_175626_b(tile.func_174877_v(), 0));
						Tessellator.func_178181_a().func_78381_a();
						GlStateManager.func_179121_F();
						GlStateManager.func_179109_b(0, 1, 0);
					}
				}
			}
			GlStateManager.func_179121_F();
		}

		GlStateManager.func_179132_a(false);
		worldRenderer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
		ClientUtils.renderModelTESR(quads.get(tile.getFacing()), worldRenderer, tile.func_145831_w().func_175626_b(tile.func_174877_v(), 0));
		Tessellator.func_178181_a().func_78381_a();
		RenderHelper.func_74519_b();
		GlStateManager.func_179084_k();
		GlStateManager.func_179132_a(true);

		GlStateManager.func_179121_F();
		RenderHelper.func_74519_b();
	}
	public static void reset()
	{
		quads.clear();
		plantQuads.clear();
	}
}
